      PROGRAM Spatial
C
      include 'undefined.h'
      INCLUDE 'size.h'
      INCLUDE 'global.f'
      INCLUDE 'pointers.f'
      INCLUDE 'mpif.h'
      INTEGER IERR00,NPROCS,DIMPGR(2),PARINT(100),COMM2D,PPRANK,
     &        INDI01,INX,INY,TMAX,TSAVE,T0
      DOUBLE PRECISION PARDPR(100)
      LOGICAL PERIOD(2),RORDER
      CHARACTER*8 NAMFIL
      PARAMETER (RORDER = .FALSE.)
C
C.... Starting MPI.
      CALL MPI_INIT(IERR00)
C.... Preliminaries
      DIMPGR(1) = 0
      DIMPGR(2) = 0
      PERIOD(1) = .FALSE.
      PERIOD(2) = .FALSE.
C.... Creating the virtual topology.
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NPROCS,IERR00)
      CALL MPI_DIMS_CREATE(NPROCS,2,DIMPGR,IERR00)
      CALL MPI_CART_CREATE(MPI_COMM_WORLD,2,DIMPGR,PERIOD,RORDER,
     &                     COMM2D,IERR00)
      CALL MPI_COMM_RANK(COMM2D,PPRANK,IERR00)
C.... Reading data.
      DO INDI01 = 1, 100
         PARINT(INDI01) = 0
	 PARDPR(INDI01) = 0.D0
      ENDDO
      IF(PPRANK.EQ.0) THEN
        CALL READ_STDIN()
        CALL READGLOB(PARINT,PARDPR)
      ENDIF
      CALL MPI_BARRIER(COMM2D,IERR00)
C.... Spreading some data.
      CALL DASPRD(PARINT,PARDPR,COMM2D)
C.... Obtaining information about virtual topology.
      CALL INFOTP(PARINT,PARDPR,NPROCS,PPRANK,DIMPGR,COMM2D,NAMFIL)
C.... Starting SURFER
C.... Initializing calculus.
      INX  = PARINT(1)
      INY  = PARINT(2)
      TMAX = PARINT(14)
      TSAVE = PARINT(16)
      T0 = 0
      CALL INITIALIZE(PARINT,PARDPR,PPRANK,T0)
      WRITE(*,*)'RANK : ',PPRANK,' T0 =', T0
C
      write(*,*)'RANK : ',PPRANK,' -- voisins : ',PARINT(61),PARINT(62),
     &PARINT(63),PARINT(64),PARINT(65),PARINT(66),PARINT(67),PARINT(68)
C
      DO INDI01 = T0,TMAX
         CALL MPI_BARRIER(COMM2D,IERR00)
	 CALL TIMESTEP(INDI01,PARINT,PARDPR,COMM2D)
	 IF(MOD(INDI01,TSAVE).EQ.0.AND.INDI01.GT.0) THEN
	   CALL SAVE(U,V,Z(ICC(NG)),Z(IU(NG)),INX,INY,INDI01,PPRANK)
	   WRITE(*,*)'PPRANK',PPRANK,' --- Writing dump at t = '
     &               ,INDI01,' ---'
	 ENDIF
      ENDDO
C
      CALL MPI_FINALIZE(IERR00)
C
      end
C***********************************************************************
      SUBROUTINE initialize(parint,pardpr,pprank,t0)
      include 'undefined.h'
      INTEGER restart,parint(100),pprank,t0
      DOUBLE PRECISION pardpr(100)
      INCLUDE 'size.h'
      INCLUDE 'global.f'
      INCLUDE 'pointers.f'
C
      nx = PARINT(1)
      ny = PARINT(2)
      restart = PARINT(3)
      tau = PARDPR(1)
      call initpressure(parint,pardpr,pprank)
      if(restart.eq.0) then
c
c Include here relevant initialisation module
c It should be called ini"something". 
c
        call inizero(u,v,z(icc(ng)),z(iu(ng)),nx,ny,tau)
      else
        call iniget(u,v,z(icc(ng)),z(iu(ng)),nx,ny,t0,pprank)
	t0=t0+1
        write (*,*) 'PPRANK',PPRANK,' --- RESTARTING AT T =',t0,
     &              ' WITH DUMP FILE ---'
      endif
C
      return
      end
