      SUBROUTINE BUPDAT(U,PARINT,PARDPR,INX,INY,COMM2D)
C
C     Name: Boundaries UPDATe
C     Authors: Enrique LOPEZ-PAGES & Anthony Leboissetier
C     Objective: To update the process borders.
C     Called by: ciam_raus, momentum, time_step & mglin
C     It calls: PACKER & PACKERD
C     Modifications :
C
      IMPLICIT NONE
      INCLUDE 'mpif.h'
      INTEGER PPRANK,NEIGHB(8),PARINT(100),INX,INY,IERR00,MLPACK,
     &        INDI01,INDI02,NPRANK,NUMFAC,COMM2D,
     &        STAT00(MPI_STATUS_SIZE),SEQFAC
      DOUBLE PRECISION PARDPR(100),PCOORS(10),SPACKN(INX),
     &                 SPACKS(INX),SPACKE(INX),SPACKW(INX),
     &                 RPACKN(INX),RPACKS(INX),
     &                 RPACKE(INX),RPACKW(INX)
      DOUBLE PRECISION RPACKNE,RPACKSE,RPACKSW,RPACKNW
      DOUBLE PRECISION U(INX,INY)
      LOGICAL PCKDIR
      CHARACTER*6 NAMSUB
C
C.... Preliminaries
      NAMSUB = 'BUPDAT'
      NUMFAC = 4
      DO INDI01 = 1,8
         NEIGHB(INDI01) = PARINT(60 + INDI01)
      ENDDO
      PPRANK = PARINT(55)
      MLPACK = INX
      CALL MPI_TYPE_CONTIGUOUS(MLPACK,MPI_DOUBLE_PRECISION,SEQFAC,
     &                         IERR00)
      CALL MPI_TYPE_COMMIT(SEQFAC,IERR00)
C
      DO INDI01 = 1,MLPACK
         SPACKN(INDI01) = 0.D0
         SPACKS(INDI01) = 0.D0
	 SPACKE(INDI01) = 0.D0
	 SPACKW(INDI01) = 0.D0
         RPACKN(INDI01) = 0.D0
	 RPACKS(INDI01) = 0.D0
	 RPACKE(INDI01) = 0.D0
	 RPACKW(INDI01) = 0.D0
      ENDDO
C
      RPACKNE = 0.D0
      RPACKSE = 0.D0
      RPACKSW = 0.D0
      RPACKNW = 0.D0 
C     Packing before sending (Faces order: N, S, E and W).
      PCKDIR = .TRUE.
      CALL PACKER(PCKDIR,U,SPACKN,1,INX,INY)
      CALL PACKER(PCKDIR,U,SPACKS,3,INX,INY)
      CALL PACKER(PCKDIR,U,SPACKE,2,INX,INY)
      CALL PACKER(PCKDIR,U,SPACKW,4,INX,INY)
C.... Contacting neighbours.
C     Main neighbours at Y coordinate.
      IF(NEIGHB(1).GE.0) THEN
c	WRITE(6,*)'> ',PPRANK,' WITH MAIN ',NEIGHB(1),' AT NORTH'
	CALL MPI_SENDRECV(SPACKN(1),1,SEQFAC,NEIGHB(1),
     &   100,RPACKN(1),1,SEQFAC,NEIGHB(1),200,COMM2D,STAT00,IERR00)
      ENDIF
      IF(NEIGHB(5).GE.0) THEN
c	WRITE(6,*)'> ',PPRANK,' WITH MAIN ',NEIGHB(5),' AT SOUTH'
	CALL MPI_SENDRECV(SPACKS(1),1,SEQFAC,NEIGHB(5),
     &	 200,RPACKS(1),1,SEQFAC,NEIGHB(5),100,COMM2D,STAT00,IERR00)
      ENDIF
C     Main neighbours at X coordinate.
      IF(NEIGHB(3).GE.0) THEN
c	WRITE(6,*)'> ',PPRANK,' WITH MAIN ',NEIGHB(3),' AT EAST'
	CALL MPI_SENDRECV(SPACKE(1),1,SEQFAC,NEIGHB(3),
     &   300,RPACKE(1),1,SEQFAC,NEIGHB(3),400,COMM2D,STAT00,IERR00)
      ENDIF
      IF(NEIGHB(7).GE.0) THEN
c	WRITE(6,*)'> ',PPRANK,' WITH MAIN ',NEIGHB(7),' AT WEST'
	CALL MPI_SENDRECV(SPACKW(1),1,SEQFAC,NEIGHB(7),
     &   400,RPACKW(1),1,SEQFAC,NEIGHB(7),300,COMM2D,STAT00,IERR00)
      ENDIF
C
C.... Unpacking after receiving.(borders)
      PCKDIR = .FALSE.
      IF(NEIGHB(1).GE.0) THEN
        CALL PACKER(PCKDIR,U,RPACKN,1,INX,INY)
      ENDIF
      IF(NEIGHB(5).GE.0) THEN
        CALL PACKER(PCKDIR,U,RPACKS,3,INX,INY)
      ENDIF
      IF(NEIGHB(3).GE.0) THEN
        CALL PACKER(PCKDIR,U,RPACKE,2,INX,INY)
      ENDIF
      IF(NEIGHB(7).GE.0) THEN
        CALL PACKER(PCKDIR,U,RPACKW,4,INX,INY)
      ENDIF
C
c     Diagonal neighbours.
      IF(NEIGHB(2).GE.0) THEN
c	WRITE(6,*)'> ',PPRANK,' WITH DIAG ',NEIGHB(2)
	CALL MPI_SENDRECV(SPACKN(MLPACK-1),1,MPI_DOUBLE_PRECISION,
     &	     NEIGHB(2),110,RPACKNE,1,MPI_DOUBLE_PRECISION,NEIGHB(2),210,
     &       COMM2D,STAT00,IERR00)
      ENDIF
      IF(NEIGHB(6).GE.0) THEN
c	WRITE(6,*)'> ',PPRANK,' WITH DIAG ',NEIGHB(6)
	CALL MPI_SENDRECV(SPACKS(2),1,MPI_DOUBLE_PRECISION,
     &	     NEIGHB(6),210,RPACKSW,1,MPI_DOUBLE_PRECISION,NEIGHB(6),110,
     &       COMM2D,STAT00,IERR00)
      ENDIF
      IF(NEIGHB(8).GE.0) THEN
c	WRITE(6,*)'> ',PPRANK,' WITH DIAG ',NEIGHB(8)
	CALL MPI_SENDRECV(SPACKN(2),1,MPI_DOUBLE_PRECISION,
     &	     NEIGHB(8),310,RPACKNW,1,MPI_DOUBLE_PRECISION,NEIGHB(8),410,
     &       COMM2D,STAT00,IERR00)
      ENDIF
      IF(NEIGHB(4).GE.0) THEN
c	WRITE(6,*)'> ',PPRANK,' WITH DIAG ',NEIGHB(4)
	CALL MPI_SENDRECV(SPACKS(MLPACK-1),1,MPI_DOUBLE_PRECISION,
     &	     NEIGHB(4),410,RPACKSE,1,MPI_DOUBLE_PRECISION,NEIGHB(4),310,
     &       COMM2D,STAT00,IERR00)
      ENDIF
C
C.... Unpacking after receiving.(corners)
      IF(NEIGHB(2).GE.0) THEN
        CALL PACKERD(U,RPACKNE,1,INX,INY)
      ENDIF
      IF(NEIGHB(4).GE.0) THEN
        CALL PACKERD(U,RPACKSE,3,INX,INY)
      ENDIF
      IF(NEIGHB(6).GE.0) THEN
        CALL PACKERD(U,RPACKSW,2,INX,INY)
      ENDIF
      IF(NEIGHB(8).GE.0) THEN
        CALL PACKERD(U,RPACKNW,4,INX,INY)
      ENDIF
C... Freeing the SEQFAC type
      CALL MPI_Type_free(SEQFAC,IERR00)
C
      RETURN
      END
C
      SUBROUTINE PACKER(PCKDIR,U,AARRAY,INDFAC,INX,INY)
C
C     Name: Self-explained
C     Author: Enrique LOPEZ-PAGES
C     Objective: To pack and unpack shared data.
C     Called by: BUPDAT
C     It calls: None
C     Modifications : Anthony Leboissetier (09/01)
C
      IMPLICIT NONE
      INTEGER INDFAC,INX,INY,INDI01,INDI02,INDI03,
     &        INDIXF,INDIXL,INDIYF,INDIYL
      DOUBLE PRECISION U(INX,INY),AARRAY(INX)
      LOGICAL PCKDIR
      CHARACTER*6 NAMSUB
C
      NAMSUB = 'PACKER'
C.... Testing
c      WRITE(6,*)'-',NAMSUB,' PCKDIR ',PCKDIR
      IF(INDFAC.EQ.1) THEN
        INDIXF = 1
	INDIXL = INX
	INDIYF = INY-1
	INDIYL = INY-1
	IF(.NOT.PCKDIR) INDIYF = INY
	IF(.NOT.PCKDIR) INDIYL = INY
	ELSEIF(INDFAC.EQ.2) THEN
	  INDIXF = INX-1
	  INDIXL = INX-1
	  INDIYF = 1
	  INDIYL = INY
	  IF(.NOT.PCKDIR) INDIXF = INX
	  IF(.NOT.PCKDIR) INDIXL = INX
	  ELSEIF(INDFAC.EQ.3) THEN
	    INDIXF = 1
	    INDIXL = INX
	    INDIYF = 2
	    INDIYL = 2
	    IF(.NOT.PCKDIR) INDIYF = 1
	    IF(.NOT.PCKDIR) INDIYL = 1
	    ELSEIF(INDFAC.EQ.4) THEN
	      INDIXF = 2
  	      INDIXL = 2
	      INDIYF = 1
	      INDIYL = INY
	      IF(.NOT.PCKDIR) INDIXF = 1
	      IF(.NOT.PCKDIR) INDIXL = 1
      ENDIF
      INDI03=1
      DO INDI02 = INDIYF,INDIYL
	 DO INDI01 = INDIXF,INDIXL
            IF(PCKDIR) THEN
	      AARRAY(  INDI03) = U(INDI01,INDI02)
	      ELSE
	      U(INDI01,INDI02) = AARRAY(  INDI03)
	    ENDIF
	    INDI03 = INDI03+1
	 ENDDO
      ENDDO
C
      RETURN
      END
c
      SUBROUTINE PACKERD(U,VAL,INDFAC,INX,INY)
C
C     Name: PACKER Diagonals
C     Author: Anthony LEBOISSETIER
C     Objective: To unpack shared data in the corners
C     Called by: BUPDAT
C     It calls: None
C     Modifications :
C
      IMPLICIT NONE
      INTEGER INDFAC,INX,INY,INDI01,INDI02,INDI03,INDX,INDY
      DOUBLE PRECISION U(INX,INY),VAL
      CHARACTER*6 NAMSUB
C
      NAMSUB = 'PACKERD'
C.... Testing
c      WRITE(6,*)'-',NAMSUB,' PCKDIR ',PCKDIR
      IF(INDFAC.EQ.1) THEN
        INDX = INX
	INDY = INY
	ELSEIF(INDFAC.EQ.2) THEN
	  INDX = 1
	  INDY = 1
	  ELSEIF(INDFAC.EQ.3) THEN
	    INDX = INX
	    INDY = 1
	    ELSEIF(INDFAC.EQ.4) THEN
	      INDX = 1
	      INDY = INY
      ENDIF
C
      U(INDX,INDY) = VAL
C
      RETURN
      END
