      SUBROUTINE INFOTP(PARINT,PARDPR,NPROCS,PPRANK,DIMPGR,COMM2D,
     &                  NAMFIL)
C
C     Name: MPI Begin
C     Author: Enrique LOPEZ-PAGES
C     Objective: To characterize the virtual topology.
C     Called by: Spatial
C     It calls: 
C     Modifications:
C
C     NPROCS: Number of PROCesseS.
C     DIMPGR: Dimension of Processes GRid.
C     PGRCXY: Process (in GRid) Coordinates XY.
C     NCELLX: Number of CELLs in X dir.
C     PERIOD: PERIODicity.
C     RORDER: Re-ORDER of 2D grid.
C 
      IMPLICIT NONE
      INCLUDE 'mpif.h' 
      INTEGER IERR00,STAT00(MPI_STATUS_SIZE),PPRANK,COMM2D,NPROCS,
     &        DIMPGR(2),NEIGHB(8),PGRCXY(2),PARINT(100),ADECEN,AUNITY,
     &        INDI01,INEIG1,INEIG2,INEIG3,INEIG4,NCELLX,NCELLY
      DOUBLE PRECISION PARDPR(100),DELTAX,LNGTHX,LNGTHY,PCOOR1,PCOOR2
      LOGICAL PERIOD(2),RORDER
      CHARACTER ADIGIT(10)
      CHARACTER*6 NAMSUB
      CHARACTER*8 NAMFIL
      PARAMETER (RORDER = .FALSE.)
      DATA (ADIGIT(INDI01),INDI01 = 1,10)/'0','1','2','3','4','5','6',
     &      '7','8','9'/
C
C.... Preliminaries
      NAMSUB = 'INFOTP'
      PGRCXY(1) = 0
      PGRCXY(2) = 0
      PERIOD(1) = .FALSE.
      PERIOD(2) = .FALSE. 
      INEIG1 = -1
      INEIG2 = -1
      INEIG3 = -1
      INEIG4 = -1
      DO INDI01 = 1,8
         NEIGHB(INDI01) = -1
      ENDDO
C.... Obtaining information for the topology.
      CALL MPI_CART_GET(COMM2D,2,DIMPGR,PERIOD,PGRCXY,IERR00)
C.... Cherching for main neighbours.
      CALL MPI_CART_SHIFT(COMM2D,0,1,NEIGHB(7),NEIGHB(3),IERR00)
      CALL MPI_CART_SHIFT(COMM2D,1,1,NEIGHB(5),NEIGHB(1),IERR00)
C.... Upgrading NEIGHB array for diagonal neighbours.
      IF(NEIGHB(1).GE.0) THEN
        INEIG1 = NEIGHB(3)
        INEIG2 = NEIGHB(7)
        CALL MPI_SEND(INEIG1,1,MPI_INTEGER,NEIGHB(1),100,COMM2D,
     &                IERR00)
        CALL MPI_SEND(INEIG2,1,MPI_INTEGER,NEIGHB(1),200,COMM2D,
     &                IERR00)
        CALL MPI_RECV(INEIG3,1,MPI_INTEGER,NEIGHB(1),300,COMM2D,
     &                STAT00,IERR00)
        CALL MPI_RECV(INEIG4,1,MPI_INTEGER,NEIGHB(1),400,COMM2D,
     &                STAT00,IERR00)
        NEIGHB(2) = INEIG3
        NEIGHB(8) = INEIG4
      ENDIF
      IF(NEIGHB(5).GE.0) THEN
        INEIG1 = NEIGHB(3)
        INEIG2 = NEIGHB(7)
        CALL MPI_RECV(INEIG3,1,MPI_INTEGER,NEIGHB(5),100,COMM2D,
     &                STAT00,IERR00)
        CALL MPI_RECV(INEIG4,1,MPI_INTEGER,NEIGHB(5),200,COMM2D,
     &                STAT00,IERR00)
        CALL MPI_SEND(INEIG1,1,MPI_INTEGER,NEIGHB(5),300,COMM2D,
     &                IERR00)
        CALL MPI_SEND(INEIG2,1,MPI_INTEGER,NEIGHB(5),400,COMM2D,
     &                IERR00)
        NEIGHB(4) = INEIG3
        NEIGHB(6) = INEIG4
      ENDIF
C.... Determination of each process physical coordinates.
      NCELLX = PARINT(1) - 2
      NCELLY = PARINT(2) - 2
      LNGTHX = 1.D0/DIMPGR(1)
      DELTAX = LNGTHX/NCELLX
      LNGTHY = NCELLY*DELTAX
      PCOOR1 = PGRCXY(1)*LNGTHX
      PCOOR2 = PGRCXY(2)*LNGTHY
      
c      write(6,*),'TONY --- proc ',PPRANK,' - NCELLX = ',NCELLX
c      write(6,*),'TONY --- proc ',PPRANK,' - NCELLX = ',NCELLX
c      write(6,*),'TONY --- proc ',PPRANK,' - DIMPGR(1) = ',DIMPGR(1)
c      write(6,*),'TONY --- proc ',PPRANK,' - DIMPGR(2) = ',DIMPGR(2)
c      write(6,*),'TONY --- proc ',PPRANK,' - LNGTHX = ',LNGTHX
c      write(6,*),'TONY --- proc ',PPRANK,' - DELTAX = ',DELTAX
c      write(6,*),'TONY --- proc ',PPRANK,' - LNGTHY = ',LNGTHY
c      write(6,*),'TONY --- proc ',PPRANK,' - PGRCXY(1) = ',PGRCXY(1)
c      write(6,*),'TONY --- proc ',PPRANK,' - PGRCXY(2) = ',PGRCXY(2)
c      write(6,*),'TONY --- proc ',PPRANK,' - PCOOR1 = ',PCOOR1
c      write(6,*),'TONY --- proc ',PPRANK,' - PCOOR2 = ',PCOOR2
      
C.... Inserting some data in the main arrays
C....                                        --- PARINT.
      PARINT(50) = NPROCS
      PARINT(51) = DIMPGR(1)
      PARINT(52) = DIMPGR(2)
      PARINT(53) = PGRCXY(1)
      PARINT(54) = PGRCXY(2)
      PARINT(55) = PPRANK
      PARINT(61) = NEIGHB(1)
      PARINT(62) = NEIGHB(2)
      PARINT(63) = NEIGHB(3)
      PARINT(64) = NEIGHB(4)
      PARINT(65) = NEIGHB(5)
      PARINT(66) = NEIGHB(6)
      PARINT(67) = NEIGHB(7)
      PARINT(68) = NEIGHB(8)
C....                                        --- PARDPR
      PARDPR(51) = DELTAX
      PARDPR(52) = LNGTHX
      PARDPR(53) = LNGTHY
      PARDPR(54) = PCOOR1
      PARDPR(55) = PCOOR2
C.... File for outputs.
C      NAMFIL = 'OFILE'
C      NAMFIL(6:6) = '-'
C      AUNITY = MOD(PPRANK,10) + 1
C      ADECEN = MOD(PPRANK/10,10) + 1
C      NAMFIL(7:7) = ADIGIT(ADECEN)
C      NAMFIL(8:8) = ADIGIT(AUNITY)
C      OPEN(31,FILE = NAMFIL,STATUS = 'UNKNOWN',FORM = 'UNFORMATTED')
C
      RETURN
      END
