      SUBROUTINE MAKEBC(IBCTYP,ICFTYP,INADD0,VARIAB,VALUE1,VALUE2,
     &           OUTVAL,COFRST,COLAST,PARINT,PARDPR,PPRANK,INX,INY)
C
C     Author: Enrique LOPEZ-PAGES
C     Name: MAKE Boundary Conditions
C     Purpose: To apply different types of boundary conditions
C     Called by: MAKEBCV, MAKEBCC, MAKEBCFLUX, MAKEBCS, MAKEBCRESF & MAKEBCPF
C     It calls: None
C     Modifications: Anthony Leboissetier (09/01)
C
      IMPLICIT NONE
      INTEGER IBCTYP,ICFTYP,INDIXF,INDIXL,INDIYF,INDIYL,PPRANK,MAXNUM,
     &        INX,INY,INDI01,INDI02,INADD0,INADD1,INADD2,INADD3,INADD4,
     &        NPROCX,PARINT(100)
      DOUBLE PRECISION VARIAB(INX,INY),VALUE1,VALUE2,PARDPR(100),
     &                 OUTVAL,VVALUE,COFRST,COLAST,DELTAT,DELTAX,
     &                 XIPROC,XFPROC,YIPROC,YFPROC,TMPVAL,TMPSUM,H
      CHARACTER*6 NAMSUB,BCNAME
C
C.... Preliminaries
      NAMSUB = 'MAKEBC'
      TMPVAL = 0.D0
      TMPSUM = 0.D0
      OUTVAL = 0.D0
      INADD1 = 0
      INADD2 = 0
      INADD3 = 0
      INADD4 = 0
      INDIXF = 0
      INDIXL = 0
      INDIYF = 0
      INDIYL = 0
      DELTAT = PARDPR(1)
      DELTAX = PARDPR(51)
      XIPROC = PARDPR(54)
      XFPROC = PARDPR(54) + PARDPR(52)
      YIPROC = PARDPR(55)
      YFPROC = PARDPR(55) + PARDPR(53)
      NPROCX = PARINT(51)
      H = 1./(INX-2)
      IF(ICFTYP.EQ.1.OR.ICFTYP.EQ.3) THEN
        TMPVAL = (COFRST - XIPROC)/DELTAX
	INDIXF = 2 + TMPVAL
	TMPVAL = (XFPROC - COLAST)/DELTAX
	INDIXL = INX - TMPVAL - 1
	IF(ICFTYP.EQ.3) THEN
	  INDIYF = 1 + INADD0
	  INDIYL = 1 + INADD0
	  ELSE
	  INDIYF = INY - INADD0
	  INDIYL = INY - INADD0
	ENDIF
	MAXNUM = INDIXL
        ELSE
	TMPVAL = (COFRST - YIPROC)/DELTAX
	INDIYF = 2 + TMPVAL
	TMPVAL = (YFPROC - COLAST)/DELTAX
	INDIYL = INY - TMPVAL - 1
	IF(ICFTYP.EQ.4) THEN
	  INDIXF = 1 + INADD0
	  INDIXL = 1 + INADD0
	  ELSE
	  INDIXF = INX - INADD0
	  INDIXL = INX - INADD0
	ENDIF
	MAXNUM = INDIYL
      ENDIF
      IF(INDIYF.EQ.INDIYL) THEN
        IF(INDIYF.EQ.1) THEN
          INADD1 =  0
	  INADD2 =  1
	  ELSE
	  INADD1 =  0
	  INADD2 = -1
	ENDIF
	ELSE
	IF(INDIXF.EQ.1) THEN
  	  INADD1 =  1
	  INADD2 =  0
	  ELSE
	  INADD1 = -1
	  INADD2 =  0
	ENDIF
      ENDIF
C.... Inlet Boundary Condition
      IF(IBCTYP.EQ.1) THEN
        BCNAME = 'INLET '
	VVALUE = VALUE1*DELTAT/H
      ENDIF
C.... Outlet Boundary Condition
      IF(IBCTYP.EQ.2) THEN
        BCNAME = 'OUTLET'
	VVALUE = VALUE1/(NPROCX*(INX-2))
      ENDIF
C.... Fixed Value Boundary Condition
      IF(IBCTYP.EQ.3) THEN
        BCNAME = 'FIXVAL'
	VVALUE = VALUE1
      ENDIF
C.... Fixed Flux Boundary Condition
      IF(IBCTYP.EQ.4) THEN
        BCNAME = 'FIXFLU'
	VVALUE = VALUE1
      ENDIF
C.... Collect of data for the exit conditions
      IF(IBCTYP.EQ.5) THEN
        BCNAME = 'COLLECT'
	VVALUE = VALUE1
	INADD1 = 0
	INADD2 = 0
      ENDIF
C
      DO INDI02 = INDIYF,INDIYL
	DO INDI01 = INDIXF,INDIXL
	  VARIAB(INDI01,INDI02) = VVALUE + VALUE2*
     &                            VARIAB(INDI01+INADD1,INDI02+INADD2)
	  TMPSUM = TMPSUM + VARIAB(INDI01,INDI02)
	 ENDDO
      ENDDO
      IF(IBCTYP.EQ.1.OR.IBCTYP.EQ.2.OR.IBCTYP.EQ.5) OUTVAL = TMPSUM
      RETURN
      END
