      SUBROUTINE timestep(T,PARINT,PARDPR,COMM2D)
      include 'undefined.h'
      INCLUDE 'size.h'
      INCLUDE 'global.f'
      INCLUDE 'pointers.f'
      INTEGER tprint,tvelo,t,cinalg,PARINT(100),NEIGHB(8)
      INTEGER printdiv,i,j,nfilter,PPRANK,INDI01,INDI02,COMM2D
      DOUBLE PRECISION  velmax,sumfield,tau1,PARDPR(100),PCOORS(4),
     &                  OUTVAL
      real*8 findninf,findmax,findmin
      character*80 c
C
      NX = PARINT(1)
      NY = PARINT(2)
      printdiv = parint(10)
      tprint   = PARINT(15)
      PPRANK   = PARINT(55)
      DO i = 1,8
         NEIGHB(I) = PARINT(60+I)
      ENDDO
      PCOORS(1) = PARDPR(54)
      PCOORS(2) = PARDPR(54) + PARDPR(52)
      PCOORS(3) = PARDPR(55)
      PCOORS(4) = PARDPR(55) + PARDPR(53)
C
C.... Real physical boundaries.
        CALL MAKEBCV(U,V,PARINT,PARDPR,NX,NY,COMM2D,T)
	CALL MAKEBCC(z(icc(ng)),PARINT,PARDPR,NX,NY)
C
C.... Updating boundaries for u,v,c and p
      CALL BUPDAT(U,PARINT,PARDPR,NX,NY,COMM2D)
      CALL BUPDAT(V,PARINT,PARDPR,NX,NY,COMM2D)
      CALL BUPDAT(z(icc(ng)),PARINT,PARDPR,NX,NY,COMM2D)
      CALL BUPDAT(z(iu(ng)),PARINT,PARDPR,NX,NY,COMM2D)
C
      if(t.eq.0)  write(6,*) 'printdiv= ',printdiv
C.... Controling CFL condition
      velmax = findninf(u,v,nx,ny)
c     WRITE(6,*)'RANK= ',PPRANK,' velmax= ',velmax
      if(velmax.gt.MAXCFL) then
        WRITE(6,*)'RANK= ',PPRANK
        WRITE(6,*)'RANK= ',PPRANK,' SURFER: Warning! -> t= ',
     &	           T,' velmax= ',velmax
        STOP 'CFL Number too large. Try smaller tau'
      endif
      IF(VELMAX.LT.1.D-10) VELMAX = 1.D-10
C.... Some output
      if(mod(t,tprint).eq.0) then
         write(6,*) 'RANK = ',PPRANK,' tstep = ',t,' - CFL > ',velmax
         write(6,*) 'RANK = ',PPRANK,' mass = ',
     &	 sumfield(z(icc(ng)),nx,ny)
         write(6,*) 'RANK = ',PPRANK,' max C= ', 
     &	             findmax(z(icc(ng)),nx,ny,i,j), 
     &              'RANK = ',PPRANK,' min C= ', 
     &               findmin(z(icc(ng)),nx,ny,i,j)
      endif
C.... Output U,V and C fields
c      i=ifetch("tvelo",tvelo)
      tvelo = PARINT(11)
      if(mod(t,tvelo).eq.0) then
        call datbfile(u,v,z(icc(ng)),nx,ny,1,t,PPRANK)
      endif
c
c  Calls CIAM
c
      call ciam_raus(u,v,z(icc(ng)),z(iei(ng)),z(ires(ng)),z(irhs(ng)),
     $     z(ia(ng)),z(ic(ng)),S11,nx,ny,PARDPR,PARINT,PPRANK,COMM2D)
C.... Physical constants
      sigma = PARDPR(2)
      rhogas = PARDPR(3)
      muliq = PARDPR(4)
      mugas = PARDPR(5)
      if(sigma.eq.0.d0) then
         call fill0(S11,nx,ny)
         call fill0(S22,nx,ny)
         call fill0(S12,nx,ny)
         else
c
c gets a parameter to determine whether we filter C before 
c computing spurious currents. 
c
         nfilter = PARINT(13)
         if(nfilter.eq.0) then
            call stresses(S11,S22,S12,z(icc(ng)),z(iei(ng)),
     $                    z(ires(ng)),sigma,tau,nx,ny,PARDPR)
            else
c
c  z(irhs(ng)) will now be a pointer to the filtered volume fraction field
c
            call filter(z(icc(ng)),z(irhs(ng)),nx,ny)
C.... Next BC is substituted by one call to MAKEBCC (Tony).
C            call makebccf(z(irhs(ng)),nx,ny)
            call makebcc(z(irhs(ng)),PARINT,PARDPR,nx,ny)
	    CALL BUPDAT(z(icc(ng)),PARINT,PARDPR,NX,NY,COMM2D)
            do i=1,nfilter-1
	      call copy(z(iei(ng)),z(irhs(ng)),nx,ny)
              call filter(z(iei(ng)),z(irhs(ng)),nx,ny)
C.... Next BC is substituted by one call to MAKEBCC (Tony).
C            call makebccf(z(irhs(ng)),nx,ny)
              call makebcc(z(irhs(ng)),PARINT,PARDPR,nx,ny)
	      CALL BUPDAT(z(icc(ng)),PARINT,PARDPR,NX,NY,COMM2D)
            enddo
	    call stresses(S11,S22,S12,z(irhs(ng)),z(iei(ng)),
     $                    z(ires(ng)),sigma,tau,nx,ny,PARDPR)
         endif
      endif
      call momentum(rhou,rhov,u,v,z(icc(ng)),z(iu(ng)),z(ia(ng)),
     *              z(ic(ng)),z(iei(ng)),S11,S22,S12,
     *              z(ires(ng)),z(irhs(ng)),tau,mugas,muliq,rhogas,g,
     *              nx,ny,printdiv,t,PARINT,PARDPR,COMM2D)
      return
      end
